;ISF_Functions.au3

Func _ISFCreateISFfile($file = "")
	Local $h = $hScriptGui ; Handle to the Main Gui
	$sISFfile = FileSaveDialog("Select ISF File to Create",@workingdir,"ISN Form Studio 2 Files (*.isf)",2+16,$file & ".isf",$h)
;~ 	If $sISFfile = "" Then _ScriptExit()
	If $sISFfile = "" Then Return 1
	
	If FileExists($sISFfile) Then
;~ 		If MsgBox(4+32+256,"Question....","Really Overwrite the File?" & @LF & $sISFfile) = 7 Then Return SetError(1)
		FileDelete($sISFfile)
	EndIf
	; Create ISF File
	
	FileClose(FileOpen($sISFfile,1+8))
	FileWrite($sISFfile,$sScriptBRAND & @LF & "#cs" & @LF & "[gui]"); Write Header
EndFunc


Func _ISFSetMain()
	_KodaReadMainToArray($sKodaPathFile)
	
;~ 	_ArrayDisplay($aKodaGuiAttributes, "KodaGuiAttributes")
;~ 	_ArrayDisplay($aKodaGuiValues, "KodaGuiValues")
;~ 	_ArrayDisplay($aKodaGuiName, "KodaGuiName")

	_KodaSetStruct($strGuiMain,$aKodaGuiAttributes,$aKodaGuiValues,$aKodaGuiName[1][2],$aKodaGuiName[2][2],"gui")
	_ISFWriteMain($strGuiMain)
EndFunc
	
Func _ISFWriteMain(ByRef $struct)
	IniWrite($sISFfile,"gui","Handle_deklaration",DllStructGetData($struct, "optvarscope"))
	IniWrite($sISFfile,"gui","title",DllStructGetData($struct, "caption"))
	IniWrite($sISFfile,"gui","breite",DllStructGetData($struct, "width"))
	IniWrite($sISFfile,"gui","hoehe",DllStructGetData($struct, "height"))
	IniWrite($sISFfile,"gui","style",DllStructGetData($struct, "style"))
	IniWrite($sISFfile,"gui","exstyle",DllStructGetData($struct, "exstyle"))
	IniWrite($sISFfile,"gui","bgcolour",DllStructGetData($struct, "bkcolor"))
	IniWrite($sISFfile,"gui","bgimage",DllStructGetData($struct,"bgimage"))
	IniWrite($sISFfile,"gui","handle",DllStructGetData($struct, "name"))
	IniWrite($sISFfile,"gui","parent",DllStructGetData($struct, "parent"))
	IniWrite($sISFfile,"gui","code",$sScriptBRAND & "[BREAK]" & DllStructGetData($struct,"code"))
	IniWrite($sISFfile,"gui","xpos",DllStructGetData($struct, "posx"))
	IniWrite($sISFfile,"gui","ypos",DllStructGetData($struct, "posy"))
	IniWrite($sISFfile,"gui","center_gui",DllStructGetData($struct, "centerposition"))
	IniWrite($sISFfile,"gui","title_textmode",DllStructGetData($struct,"titletextmode"))
EndFunc

Func _ISFSetComponents()
	_KodaSetComponentsCount()
	_KodaSetComponentsName()
	Local $s = "", $n,$section
	For $i = 1 To $iKodaComponentsCount Step 1
		
		$s = "//object/components/object[@"
		$s &= $aKodaComponentsName[$i*2 -1][1] & "='" & $aKodaComponentsName[$i*2 -1][2] & "'][@"
		$s &= $aKodaComponentsName[$i*2][1] & "='" & $aKodaComponentsName[$i*2][2] & "']"
;~ 		$s &= "/properties"
		$sKodaPosCurrent = $s
		_KodaSetComponentsAttributes($s & "/properties/property")
		_KodaSetComponentsValues($s & "/properties/property")
		
		If $aKodaComponentsName[$i*2 -1][2] = "TACombo" Then _KodaSetSubComponentsValues($s & "/property[@name='Items.Strings']/list/li")
		If $aKodaComponentsName[$i*2 -1][2] = "TATab" Then _KodaSetSubComponentsAttributes($s & "/components/object")
		If $aKodaComponentsName[$i*2 -1][2] = "TMainMenu" Then _KodaSetSubComponentsAttributes($s & "/components/object")
		If $aKodaComponentsName[$i*2 -1][2] = "TAMenu" Then
			_KodaSetPosMainMenu($s); Position des Menus in Array speichern
			ContinueLoop
		EndIf
;~ 		_ArrayDisplay($aKodaComponentsAttributes,"CompAttr")
;~ 		_ArrayDisplay($aKodaComponentsValues,"CompVal")
;~ 		_ArrayDisplay($aKodaComponentsName,"CompName")
;~ 		_ArrayDisplay($aKodaSubComponentsAttributes,"CompSubVal")
;~ 		_ArrayDisplay($aKodaSubComponentsValues,"CompSubAttr")
		
		$section = _ISFGetNextSectionName()
		$n = $iISFSection
		Switch _KodaSetStruct($strGuiControl, $aKodaComponentsAttributes,$aKodaComponentsValues, _
					$aKodaComponentsName[$i*2-1][2],$aKodaComponentsName[$i*2][2],$section,$n)
			Case "tab"
				; nicht speichern, ist bereits erledigt.
			Case "mainmenu"
				; nicht speichern, ist bereits erledigt.
			Case Else
				_ISFWriteComponents($strGuiControl)
		EndSwitch
;~ 		_ArrayDisplay($aKodaComponentsAttributes, "KodaComponentsAttributes")
;~ 		_ArrayDisplay($aKodaComponentsValues, "KodaComponentsValues")
;~ 		_ArrayDisplay($aKodaComponentsName, "KodaComponentsName")
;~ 		ExitLoop; entfernen!
	Next
	FileWrite($sISFfile,@LF & "#ce")
EndFunc

Func _ISFWriteComponents(ByRef Const $struct)
	Local $section = DllStructGetData($struct,"section"); nur interne benutzung, daher mit Counter
;~ 		MsgBox("","handle",DllStructGetData($struct,"handle"))
	IniWrite($sISFfile,$section,"handle",DllStructGetData($struct,"handle")); wert muss noch eingetragen werden
	IniWrite($sISFfile,$section,"locked",DllStructGetData($struct,"lock")); wird nicht von KODA untersttzt
	IniWrite($sISFfile,$section,"code",DllStructGetData($struct,"code"))
	IniWrite($sISFfile,$section,"type",DllStructGetData($struct, "type"))
	
	IniWrite($sISFfile,$section,"x",DllStructGetData($struct, "posx"))
	IniWrite($sISFfile,$section,"y",DllStructGetData($struct, "posy"))
	IniWrite($sISFfile,$section,"width",DllStructGetData($struct, "width"))
	IniWrite($sISFfile,$section,"height",DllStructGetData($struct, "height"))
	IniWrite($sISFfile,$section,"text",DllStructGetData($struct, "caption"))
	IniWrite($sISFfile,$section,"tooltip",DllStructGetData($struct, "hint"))
	IniWrite($sISFfile,$section,"state",DllStructGetData($struct,"state")); wird nicht von KODA untersttzt, wird mit Standard State gefllt
	IniWrite($sISFfile,$section,"style",DllStructGetData($struct, "style"))
	IniWrite($sISFfile,$section,"exstyle",DllStructGetData($struct, "exstyle"))
	IniWrite($sISFfile,$section,"textcolour",DllStructGetData($struct, "fontcolor"))
	IniWrite($sISFfile,$section,"bgcolour",DllStructGetData($struct, "bkcolor"))
	IniWrite($sISFfile,$section,"font",DllStructGetData($struct, "fontname"))
	IniWrite($sISFfile,$section,"fontsize",DllStructGetData($struct, "fontsize"))
	IniWrite($sISFfile,$section,"fontstyle",DllStructGetData($struct, "fontweight"))
	IniWrite($sISFfile,$section,"fontattribute",DllStructGetData($struct, "fontattr"))
	IniWrite($sISFfile,$section,"id",DllStructGetData($struct, "name")); Handle Declaration for Controls
	IniWrite($sISFfile,$section,"func",DllStructGetData($struct, "func"))
	IniWrite($sISFfile,$section,"bgimage",DllStructGetData($struct, "picpath"))
	IniWrite($sISFfile,$section,"order",DllStructGetData($struct, "taborder"))
	IniWrite($sISFfile,$section,"tabpage",DllStructGetData($struct, "tabpage"))
	IniWrite($sISFfile,$section,"textmode",DllStructGetData($struct, "textmode"))
	IniWrite($sISFfile,$section,"pages",DllStructGetData($struct, "pages")); nur bei TAB benutzt
EndFunc

Func _ISFWriteTabSheet($section,$page,$text)
	IniWrite($sISFfile,$section,"page",$page)
	IniWrite($sISFfile,$section,"text",$text)
	Iniwrite($sISFfile,$section,"textmode","text")
EndFunc

Func _ISFWriteMenu(ByRef Const $struct)
	MsgBox("","ISFWriteMenu","Wird vielleicht gar nicht gebraucht.")
	Local $section = DllStructGetData($struct,"section")
	
	IniWrite($sISFfile,$section,"handle","")
	IniWrite($sISFfile,$section,"locked","")
	IniWrite($sISFfile,$section,"code","")
	IniWrite($sISFfile,$section,"type","")
	IniWrite($sISFfile,$section,"x","")
	IniWrite($sISFfile,$section,"y","")
	IniWrite($sISFfile,$section,"width","")
	IniWrite($sISFfile,$section,"height","")
	IniWrite($sISFfile,$section,"text","")
	IniWrite($sISFfile,$section,"tooltip","")
	IniWrite($sISFfile,$section,"state","")
	IniWrite($sISFfile,$section,"style","")
	IniWrite($sISFfile,$section,"exstyle","")
	IniWrite($sISFfile,$section,"textcolour","")
	IniWrite($sISFfile,$section,"bgcolour","")
	IniWrite($sISFfile,$section,"font","")
	IniWrite($sISFfile,$section,"fontsize","")
	IniWrite($sISFfile,$section,"fontstyle","")
	IniWrite($sISFfile,$section,"fontattribute","")
	IniWrite($sISFfile,$section,"id","")
	IniWrite($sISFfile,$section,"func","")
	IniWrite($sISFfile,$section,"bgimage","")
	IniWrite($sISFfile,$section,"order","")
	IniWrite($sISFfile,$section,"tabpage","")
	IniWrite($sISFfile,$section,"textmode","")
EndFunc

Func _ISFGetNextSectionName()
	Local $section = "0x"
	$iISFSection += 1
	For $n = 1 To 8 - StringLen($iISFSection) Step 1
			$section &= "0"
	Next
	$section &= $iISFSection
	Return $section
EndFunc


