;Koda_Functions.au3


Func _KodaReadMainToArray($file)
	$oXMLopen = _XMLFileOpen($file, " ")
	If @error Then Exit ConsoleWrite("Error FileOpen: " & _XMLError() & @LF)
	
	$aKodaGuiName = _XMLGetAllAttrib("//object[@type='TAForm']")
	If @error Then ConsoleWrite("Error GetValue: " & _XMLError() & @LF)
	
	$aKodaGuiAttributes = _XMLGetAllAttrib("//object[@name='" & $aKodaGuiName[2][2] & "']/properties/property");
	If @error Then ConsoleWrite("Error GetValue: " & _XMLError() & @LF)
	
	$aKodaGuiValues = _XMLGetValue("//object/properties/property"); -> bekomme ich alle Werte aus den Properties gelesen
	If @error Then ConsoleWrite("Error GetValue: " & _XMLError() & @LF)
	
;~ 	Local $a = _XMLGetAllAttrib("//object/components/object[@type='TMainMenu'][@name='MainMenu1']" & _
;~ 		"/components/object[@type='TAMenuItem'][@name='MenuItem1']/components/object[@type='TAMenuItem'][@name='MenuItem4']/properties/property")
;~ 	_ArrayDisplay($a,"TESTING1")
;~ 	Local $a = _XMLGetValue("//object/components/object[@type='TMainMenu'][@name='MainMenu1']" & _
;~ 		"/components/object[@type='TAMenuItem'][@name='MenuItem1']/components/object[@type='TAMenuItem'][@name='MenuItem4']/properties/property")
;~ 	_ArrayDisplay($a,"TESTING2")
;~ 	Exit
EndFunc   ;==>_KodaReadMainToArray

Func _KodaSetComponentsCount()
	$iKodaComponentsCount = _XMLGetNodeCount("object/components/object")
EndFunc   ;==>_KodaSetComponentsCount

Func _KodaSetComponentsName()
	$aKodaComponentsName = _XMLGetAllAttrib("object/components/object")
EndFunc   ;==>_KodaSetComponentsName

Func _KodaSetComponentsAttributes($var)
	$aKodaComponentsAttributes = _XMLGetAllAttrib($var)
EndFunc   ;==>_KodaSetComponentsAttributes

Func _KodaSetComponentsValues($var)
	$aKodaComponentsValues = _XMLGetValue($var)
EndFunc   ;==>_KodaSetComponentsValues

Func _KodaSetSubComponentsValues($var)
	$aKodaSubComponentsValues = _XMLGetValue($var)
EndFunc   ;==>_KodaSetSubComponentsValues

Func _KodaSetSubComponentsAttributes($var)
	$aKodaSubComponentsAttributes = _XMLGetAllAttrib($var)
EndFunc   ;==>_KodaSetSubComponentsAttributes


Func _KodaSetStruct(ByRef $struct, $attr, $value, $type, $name,$section,$handle = "")
	Local $var, $var2, $ext = ""
	
	_VariableInitStruct($struct)
	_VariableSetDefValStruct($struct, $strGuiMain)
	$type = _KodaGetType($type); remove leading Info of Type (TA)
	DllStructSetData($struct, "name", $name)
	DllStructSetData($struct, "type", $type)
	DllStructSetData($struct,"handle",$handle)
	DllStructSetData($struct, "section", $section)
	DllStructSetData($struct, "state", "$GUI_SHOW+$GUI_ENABLE"); State wird nicht von KODA untersttzt, daher werden Standard States eingetragen
	DllStructSetData($struct, "textmode", "text"); TextMode wird nur aus reinem Text von KODa untersttzt, nicht aus Funktionen
	DllStructSetData($struct, "lock", "0"); Lock wird von KODA nicht dauerhaft gespeichert
	DllStructSetData($struct, "bgimage", "none"); Back Image not supported by KODA?
	DllStructSetData($struct, "fontweight", "400"); not supported by KODA
	DllStructSetData($struct, "tabpage", "-1"); Standardmig auf -1 (auerhalb des TAB) gesetzt.
	DllStructSetData($struct,"titletextmode","normal"); Standardmig auf "normal"
	DllStructSetData($struct,"pages","0"); standardmig auf 0 gesetzt, wird nur bei tab benutzt
	
	For $i = 1 To UBound($attr) - 1 Step 1
		$var2 = ""
		$ext = ""
		If $attr[$i][1] = "name" Then
			$var = $value[$attr[$i][0]][1]
			Switch $attr[$i][2]
				Case "Left";
					DllStructSetData($Struct, "posx", $var)
				Case "Top";
					DllStructSetData($Struct, "posy", $var)
				Case "Width";
					DllStructSetData($Struct, "width", $var)
				Case "Height";
					DllStructSetData($Struct, "height", $var)
				Case "Caption";
					DllStructSetData($Struct, "caption", $var)
				Case "Color";
					$var2 = _KodaGetHexColor($var, $ext)
					If $ext = "" Then
						DllStructSetData($Struct, "bkcolor", $var2)
					Else
;~ 						ConsoleWrite("Found Color in " & $name & " that needs _WINAPI_SysGetColor Function. This is added to the code." & @LF)
						DllStructSetData($struct, "code", _KodaGetAttrCodeAdd($struct, $ext, $type, "color"))
						DllStructSetData($Struct, "bkcolor", $var2)
					EndIf
				Case "Font.Charset";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "Font.Color";
					$var2 = _KodaGetHexColor($var, $ext)
					If $ext = "" Then
						DllStructSetData($Struct, "fontcolor", $var2)
					Else
;~ 						ConsoleWrite("Found Color in " & $name & " that needs _WINAPI_SysGetColor Function. This is added to the code." & @LF)
						DllStructSetData($struct, "code", _KodaGetAttrCodeAdd($struct, $ext, $type, "fontcolor"))
						DllStructSetData($Struct, "fontcolor", $var2)
					EndIf
				Case "Font.Height";
					DllStructSetData($Struct, "fontsize", _KodaGetFontHeight($var))
				Case "Font.Name";
					DllStructSetData($Struct, "fontname", $var)
;~ 					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "Font.Style";
					DllStructSetData($Struct, "fontattr", _KodaGetFontAttr($struct, $var))
				Case "OldCreateOrder";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "Position";
					Switch $var
						Case "poDesktopCenter"; - absolute position
							DllStructSetData($Struct, "centerposition", "true")
						Case "poDesigned"; - in desktop center
							DllStructSetData($Struct, "centerposition", "false")
						Case "poFixed"; - generated form position independent from position of design window
							DllStructSetData($Struct, "centerposition", "false")
					EndSwitch
				Case "Visible";
					DllStructSetData($Struct, "visible", $var)
				Case "ParentForm";
					DllStructSetData($Struct, "parent", $var)
				Case "Style";
					DllStructSetData($Struct, "style", _KodaGetGuiStyle($var))
				Case "ExStyle";
					DllStructSetData($Struct, "exstyle", _KodaGetExStyle($var))
				Case "Version";
					DllStructSetData($Struct, "version", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "OnMinimize";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "OnMaximize";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "OnRestore";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptOnEvent";
					DllStructSetData($Struct, "OPTonevent", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptExpVars";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptPopulate";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptVarsForSet";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptIndentChar";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptIndentCount";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptIndentInit";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "FormOptVarScope";
					DllStructSetData($Struct, "optvarscope", _KodaGetOptVarScope($var))
				Case "Resizing";
					$ext = _KodaGetResizing($var)
					If $ext <> "" Then
						DllStructSetData($struct, "code", _KodaGetAttrCodeAdd($struct, $ext, $type, "resizing"))
;~ 					DllStructSetData($Struct, "resizing", _KodaGetResizing($var))
					EndIf
				Case "PixelsPerInch"; ich wei nicht, was damit gemeint ist. Keine einstellung fr den Designer (nur KODA)
					DllStructSetData($Struct, "", $var); wird aber wohl nicht verwendet in ISF
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "TextHeight";
					DllStructSetData($Struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
					; Controls
				Case "CtrlStyle"
					DllStructSetData($Struct, "style", _KodaGetCtrlStyle($var, $type))
				Case "CtrlExStyle"
					DllStructSetData($Struct, "exstyle", _KodaGetExStyle($var))
;~ 					DllStructSetData($Struct, "exstyle", _KodaGetCtrlExStyle($var,$type))
				Case "TabOrder"
					DllStructSetData($Struct, "taborder", $var)
				Case "Hint"
					DllStructSetData($Struct, "hint", $var); Tooltip
;~ 				Case "State"; wird nicht von KODA untersttzt
;~ 					DllStructSetData($struct,"state",_KodaGetCtrlState($var,$type))
				Case "Hotkey"
					DllStructSetData($struct, "hotkey", "")
				Case "PicturePath"
					DllStructSetData($struct, "picpath", _KodaGetPicturePath($var, $type, $name))
				Case "ItemHeight"
					DllStructSetData($struct, "", $var)
					If @error Then ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
				Case "Date"
					DllStructSetData($struct, "date", $var)
				Case "Time"
					DllStructSetData($struct, "time", $var)
				Case "Enabled"
					If $var = "False" Then DllStructSetData($struct, "state", "$GUI_SHOW+$GUI_DISABLE")
				Case "ParentFont"
					; not needed by ISF
				Case "ItemIndex"
					DllStructSetData($struct, "code", _KodaGetAttrCodeAdd($struct, $var, $type, $attr[$i][2]))
				Case "Items.Strings"; nur bei Typ ComboBox, fgt alle Eintrge in das Feld Caption ein
					DllStructSetData($struct, "caption", _KodaGetComboItems($type))
				Case "OnClick"
					DllStructSetData($struct, "func", $var)
				Case "Menu"
					$aKodaMenuAttr[0] = $var
					_LogAdd("Found Menu Items....")
				Case Else
					ConsoleWrite("Not supported Format: " & $attr[$i][2] & @LF)
;~ 					MsgBox(64, "Error....", "Not supported Format: " & $attr[$i][2] & @LF & "Value: " & $var)
			EndSwitch
;~ 			Switch @error
;~ 			Case 2
;~ 				MsgBox("","","Fehler mit DllSctructSetData einfgen. Manche werden vllt im ISN nicht bentigt, " & _
;~ 					"dazu keinen Fehler generieren, oder gar nicht benutzen")
;~ 			EndSwitch
		EndIf
	Next
	
	If $type = "tab" Then Return _KodaSetStructTab($struct, $attr, $value, $type, $name); andere Einstellungen ntig weil TAB
	If $type = "mainmenu" Then Return _KodaSetStructMainMenu($struct, $attr, $value, $type, $name); andere einstellung ntig weil Menu
	Return $type
EndFunc   ;==>_KodaSetStruct


Func _KodaSetPosMainMenu($s); Position des Menu in Array Speichern
	Local $a = _XMLGetAllAttrib($s & "/properties/property")
	Local $a2 = _XMLGetValue($s & "/properties/property")
	Local $var
;~ 	MsgBox("","",$s)
;~ 	Local $count = (Ubound($a)-1)/2
	Local $count = Ubound($a)-1
;~ 	_ArrayDisplay($a,$count)
;~ 	_ArrayDisplay($a2,$count)
	
;~ 	_ArrayDisplay($a,"attrib")
;~ 	_ArrayDisplay($a3,"Val Menu" & $name)
	For $i = 1 to $count Step 1; Switch Attr from (Sub)Menu
;~ 		MsgBox("","Val",$a2[$i][2])
;~ 		MsgBox("","Count",$count & @LF & $i)
		If $a[$i][1] <> "name" Then ContinueLoop
		$var = $a2[$a[$i][0]][1]
		Switch $a[$i][2]
			Case "Left"
				$aKodaMenuAttr[1] = $var
			Case "Top"
				$aKodaMenuAttr[2] = $var
			Case "Width"
				$aKodaMenuAttr[3] = $var
			Case "Height"
				$aKodaMenuAttr[4] = $var
;~ 				_ArrayDisplay($aKodaMenuAttr,$i)
			Case Else
				ConsoleWrite("Not supported MenuPos Format: " & $a[$i][2] & @LF)
;~ 				MsgBox(64, "Error....", "Not supported Format: " & $attr[$i][2] & @LF & "Value: " & $var)
				
		EndSwitch
	Next
EndFunc

Func _KodaSetStructMainMenu($struct,$attr,$value,$type,$name)
	Local $count = (UBound($aKodaSubComponentsAttributes)-1)/2
	Local $s = "",$a,$n,$a2,$k,$section,$a3,$text = "",$section,$order
	
	DllStructSetData($struct,"posx",$aKodaMenuAttr[1]); Ist in einem anderen Control enthalten
	DllStructSetData($struct,"posy",$aKodaMenuAttr[2]); 
	DllStructSetData($struct,"width",$aKodaMenuAttr[3]); 
	DllStructSetData($struct,"height",$aKodaMenuAttr[4]); 
	
;~ 	_ArrayDisplay($aKodaMenuAttr)
	DllStructSetData($struct,"type","menu")
	
;~ 	_ArrayDisplay($aKodaSubComponentsAttributes,$count)
;~ 	_ISFGetNextSectionName($section)
;~ 	$text = "[" & $section & "]"
	For $i=1 To $count Step 1
		; rufe das Menu auf und schaue, ob weiter untermens vorhanden sind.
		$s = $sKodaPosCurrent & "/components/object [@type='TAMenuItem'][@name='" & $aKodaSubComponentsAttributes[$i*2][2] & "']"
		$section = _ISFGetNextSectionName()
		$order &= $section & "|"
		$text &= _KodaGetMenuText($s,$aKodaSubComponentsAttributes[$i*2][2],$section)
	Next
	; text enthlt die Menus und Untermenus
;~ 	ConsoleWrite($text & @LF)
	$text &= "[root][MBREAK]order=" & $order
	$text = StringTrimRight($text,1); Remove trailing |
;~ 	MsgBox("","Final L: " & StringLen($text),$text)
	; [MBREAK][root][MBREAK]order=0x00A279A8
	DllStructSetData($struct,"caption",$text)
;~ 	MsgBox("","Struct" & DllStructGetData($struct,"handle"),DllStructGetData($struct,"caption"))
	_ISFWriteComponents($struct)
	Return "mainmenu"
EndFunc

Func _KodaGetMenuText($menu,$name,$section = "")
	Local $text = "",$s = "",$a,$count,$a2,$a3,$n,$struct,$a4,$a5,$s2,$s3,$var
	$s = $menu
	$a2 = _XMLGetAllAttrib($s & "/properties/property")
	If @error Then ConsoleWrite("Error with XMLLGetAllAttrib: " & _XMLError() & @LF)
	$a3 = _XMLGetValue($s & "/properties/property")
	_VariableSetDefValmenuStruct($struct)
;~ 	Local $count = (Ubound($a2)-1)/2
	Local $count = Ubound($a2)-1
	
;~ 	_ArrayDisplay($a2,"attrib" & $name)
;~ 	_ArrayDisplay($a3,"Val Menu" & $name)
	For $i = 1 to $count Step 1; Switch Attr from (Sub)Menu
;~ 		MsgBox("","Val",$a2[$i][2])
;~ 		MsgBox("","Count",$count & @LF & $i)
		If $a2[$i][1] <> "name" Then ContinueLoop
		$var = $a3[$a2[$i][0]][1]
		Switch $a2[$i][2]
			Case "Caption"
				DllStructSetData($struct,"text",$var)
			Case "RadioItem"
				DllStructSetData($struct,"radio",_KodaGetBool($var))
			Case "Checked"
				DllStructSetData($struct,"checked",_KodaGetBool($var))
			Case "Enabled"
				ConsoleWrite("Not supported by ISN. Menu:Enabled" & @LF)
			Case "Hotkey"
				ConsoleWrite("Not supported by ISN. Menu:Hotkey" & @LF)
			Case Else
				ConsoleWrite("Not supported Menu Format: " & $a2[$i][2] & @LF)
;~ 				MsgBox(64, "Error....", "Not supported Format: " & $attr[$i][2] & @LF & "Value: " & $var)
				
		EndSwitch
	Next
	
	DllStructSetData($struct,"handle",$name)
	
	If $section = "" Then $section = _ISFGetNextSectionName()
	$text = "[" & $section & "]"
	$text &= "[MBREAK]handle=" & DllStructGetData($struct,"handle")
	$text &= "[MBREAK]textmode=" & DllStructGetData($struct,"textmode")
	$text &= "[MBREAK]text=" & DllStructGetData($struct,"text")
	$text &= "[MBREAK]iconmode=" & DllStructGetData($struct,"iconmode")
	$text &= "[MBREAK]iconpath=" & DllStructGetData($struct,"iconpath")
	$text &= "[MBREAK]iconvarible=" & DllStructGetData($struct,"iconvar")
	$text &= "[MBREAK]iconid=" & DllStructGetData($struct,"iconid")
	$text &= "[MBREAK]radio=" & DllStructGetData($struct,"radio")
	$text &= "[MBREAK]checked=" & DllStructGetData($struct,"checked")
	$s = $menu & "/components/object"; SubItems
	
;~ 	MsgBox("",$section,$text)
	$a = _XMLGetAllAttrib($s)
	
	If IsArray($a) = 1 Then ; SubMenu found
;~ 		_ArrayDisplay($a,"SubMenu")
		$count = (UBound($a)-1 )/2
;~ 		$count = UBound($a)-1 
		
		For $j=1 To $count Step 1
			$text &= "[MBREAK]"
			$s3 = $s & " [@type='TAMenuItem'][@name='" & $a[$j*2][2] & "']"
;~ 			Msgbox("","SubMenu Obj Name",$s)
;~ 			ConsoleWrite("SubMenu Obj Name: " & $s  & @LF)
			$section = _ISFGetNextSectionName()
			$s2 &= _KodaGetMenuText($s3,$a[$j*2][2],$section)
			DllStructSetData($struct,"childs",DllStructGetData($struct,"childs") & "|" & $section)
;~ 			MsgBox("","SubText Index: " & $j,$s2)
		Next
		$text &= "[MBREAK]childs=" & StringTrimLeft(DllStructGetData($struct,"childs"),1); Remove Leading "|"
		$text &= "[MBREAK]"
		$text &= $s2
	Else
		; no SubMenu found
		$text &= "[MBREAK]childs=-1"
		$text &= "[MBREAK]" 
	EndIf
	
;~ 	Msgbox("","intern2",$text)
	Return $text	
EndFunc

Func _KodaSetStructTab($struct, $attr, $value, $type, $name)
	; INFO: Die Funktion befindet sich noch innerhalb der <object type=TATab name=...>
;~ 	_ArrayDisplay($aKodaSubComponentsAttributes,"SubAttr")
	Local $count = (UBound($aKodaSubComponentsAttributes)-1)/2
	Local $s = "",$a,$n,$a2,$k,$section,$a3
	
	DllStructSetData($struct,"section","tab")
	DllStructSetData($struct,"pages",$count)
	Local $i1 = DllStructGetData($struct,"posx"); Position X des Tab fr die Controls speichern
	Local $i2 = DllStructGetData($struct,"posy"); Position Y des Tab fr die Controls speichern
	Local $i3 = DllStructGetData($struct,"fontsize"); Font height des Tab fr die Controls speichern
	_ISFWriteComponents($struct); das control TAB speichern
	For $i=1 To $count Step 1
		; section; page; name
		
		_ISFWriteTabSheet("TABPAGE" & $i,$i, $aKodaSubComponentsAttributes[$i*2][2])
		; hier weitere Controls einfgen je nach Tab und mit _KodaSetStruct und _ISFWriteComponents abspeichern
		; mit der Var $sKodaPosCurrent ist die Position auszulesen
		$s = $sKodaPosCurrent & "/components/object [@type='TTabSheet'][@name='" & _
					$aKodaSubComponentsAttributes[$i*2][2] & "']/components/object"
;~ 		Msgbox("","",$s)
		$a = _XMLGetAllAttrib($s); enthlt die Objekte innerhalb des TabSheet
;~ 		_ArrayDisplay($a,"TabSubComp")
		$n = _XMLGetNodeCount($s); enthlt die Anzahl der Objekte innerhalb des TabSheets
		For $j=1 To $n Step 1
			$a2 = _XMLGetAllAttrib($s & " [@type='" & $a[$j*2-1][2] & "'][@name='" & $a[$j*2][2]& "']/properties/property")
			$a3 = _XMLGetValue($s & " [@type='" & $a[$j*2-1][2] & "'][@name='" & $a[$j*2][2]& "']/properties/property")
;~ 			_ArrayDisplay($a2,"[@type='" & $a[$j*2-1][2] & "'][@name='" & $a[$j*2][2]& "']")
			$section = _ISFGetNextSectionName()
			$k = $iISFSection
			_KodaSetStruct($struct, $a2, $a3,$a[$j*2-1][2],$a[$j*2][2],$section,$k)
			; manche Werte mssen angepasst werden
			DllStructSetData($struct,"tabpage",$i-1)
			DllStructSetData($struct,"posx",DllStructGetData($struct,"posx") + $i1 + $i3)
			DllStructSetData($struct,"posy",DllStructGetData($struct,"posy") + $i2 + $i3)
			_ISFWriteComponents($struct); das control innerhalb des TABSHEET speichern
		Next
	Next
	; es mssen: TabSheets angelegt werden -> DONE
	; es mssen: Controls innerhalb der TabSheets eingepflegt werden -> DONE
	Return "tab"; die vorherige Funktion wird beendet
EndFunc   ;==>_KodaSetStructTab

Func _KodaGetFontHeight($var)
	Local $ret = ""
	; Der Wert aus KODA ist 1/3 hher als normal, zudem negativ
	$ret = Ceiling($var * 3 / 4 * -1)
	Return $ret
EndFunc   ;==>_KodaGetFontHeight

Func _KodaGetFontAttr($struct, $var)
	Local $ret = 0
;~ 	Msgbox("","KodaGetFontStyle","fsBold wird nicht so untersttzt." & @LF & $var)
	If StringInStr($var, "fsBold") = 1 Then DllStructSetData($struct, "fontweight", 300 + DllStructGetData($struct, "fontweight"))
	If StringInStr($var, "fsItalic") = 1 Then $ret += 2
	If StringInStr($var, "fsUnderline") = 1 Then $ret += 4
	If StringInStr($var, "fsStrikeOut") = 1 Then $ret += 8
	;fsBold, fsItalic, fsUnderline, fsStrikeOut
	; strikeout = 8
	; underline = 4
	; italic = 2
	; bold ndert nur die Breite des Font?
	Return $ret
EndFunc   ;==>_KodaGetFontAttr

Func _KodaGetComboItems($type)
	Local $ret = ""
	If $type <> "combo" Then Return
	; $aKodaSubComponentsValues
	For $i = 1 To UBound($aKodaSubComponentsValues) - 1 Step 1
		$ret &= $aKodaSubComponentsValues[$i][1] & "|"
	Next
	$ret = StringTrimRight($ret, 1)
;~ 	MsgBox("","",$ret)
	Return $ret
EndFunc   ;==>_KodaGetComboItems

Func _KodaGetAttrCodeAdd($struct, $var, $type, $attr)
	Local $ret = DllStructGetData($struct, "code")
;~ 	ConsoleWrite("KodaGetAttrCodeAdd: " & @LF & "Var: " & $var & @LF & "type: " & $type & @LF & "attr. " & $attr & @LF)
;~ 	MsgBox("",$attr,"Type: " & $type & @TAB & " " & DllStructGetData($struct,"name") & @LF & $attr & @LF & $var)
	Select
		Case $type = "Form" And $attr = "color"
			$ret &= "GUISetBkColor('0x' & Hex(_WinAPI_GetSysColor(" & $var & "),6),$gui_handle)[BREAK]"
		Case $type = "Form" And $attr = "fontcolor"
			$ret &= "GUICtrlSetDefColor('0x' & Hex(_WinAPI_GetSysColor(" & $var & "),6),$gui_handle)[BREAK]"
		Case $type <> "Form" And $attr = "color"
			$ret &= "GuiCtrlSetBKColor($control_handle,'0x' & Hex(_WinAPI_GetSysColor(" & $var & "),6))[BREAK]"
		Case $type <> "Form" And $attr = "fontcolor"
			$ret &= "GuiCtrlSetColor($control_handle,'0x' & Hex(_WinAPI_GetSysColor(" & $var & "),6))[BREAK]"
		Case $type <> "Form" And $attr = "resizing"
			$ret &= "GuiCtrlSetResizing($control_handle," & $var & ")[BREAK]"
		Case $type <> "Form" And $type = "combo" And $attr = "itemindex"
			$ret &= "_GUICtrlComboBox_SetCurSel($control_handle," & $var & ")[BREAK]"
	EndSelect
	Return $ret
EndFunc   ;==>_KodaGetAttrCodeAdd

Func _KodaGetPicturePath($var, $type, $name)
	Local $ret = ""
	If FileExists($var) = 0 Then
		ConsoleWrite("Picture Path File does not exist. Name: " & $name & " Type: " & $type & @LF & "Path: " & $var & @LF)
		$ret = StringReplace($var, $sScriptMainPath, "")
	Else
		$ret = StringReplace($var, $sScriptMainPath, "")
	EndIf
	Return $ret
EndFunc   ;==>_KodaGetPicturePath

Func _KodaGetResizing($var)
	Local $ret = "", $s = "", $a
	$a = StringSplit($var, ",")
	If @error Or IsArray($a) = 0 Then Return $ret = ""; no Entry found
	For $i = 1 To $a[0] Step 1
		$a[$i] = StringStripWS($a[$i], 8)
		Switch $a[$i]
			Case "DockAuto"
				$ret &= "$GUI_DOCKAUTO + "
			Case "DockLeft"
				$ret &= "$GUI_DOCKLEFT + "
			Case "DockRight"
				$ret &= "$GUI_DOCKRIGHT + "
			Case "DockTop"
				$ret &= "$GUI_DOCKTOP + "
			Case "DockBottom"
				$ret &= "$GUI_DOCKBOTTOM + "
			Case "DockHCenter"
				$ret &= "$GUI_DOCKHVENTER + "
			Case "DockVCenter"
				$ret &= "$GUI_DOCKVCENTER + "
			Case "DockWidth"
				$ret &= "$GUI_DOCKWIDTH + "
			Case "DockHeight"
				$ret &= "$GUI_DOCKHEIGHT + "
		EndSwitch
	Next
	$ret = StringTrimRight($ret, 2); Remove Trailing " +"
	Return $ret
EndFunc   ;==>_KodaGetResizing

Func _KodaGetType($type)
	Switch $type
		Case "TMainMenu"
			$type = Stringlower(StringTrimLeft($type,1))
		Case Else
			$type = StringLower(StringTrimLeft($type, 2))
	EndSwitch
	Return $type
EndFunc   ;==>_KodaGetType

Func _KodaGetCtrlStyle($var, $type)
	Local $ret = ""
;~ 	ConsoleWrite("KodaGetCtrlStyle, " & $type & @LF & $var & @LF)
	Switch $type
		Case "avi"
			If BitAND($var, $ACS_CENTER) = $ACS_CENTER Then $ret &= "$ACS_CENTER"
			If BitAND($var, $ACS_TRANSPARENT) = $ACS_TRANSPARENT Then $ret &= "$ACS_TRANSPARENT"
			If BitAND($var, $ACS_AUTOPLAY) = $ACS_AUTOPLAY Then $ret &= "$ACS_AUTOPLAY"
			If BitAND($var, $ACS_TIMER) = $ACS_TIMER Then $ret &= "$ACS_TIMER"
			If BitAND($var, $ACS_NONTRANSPARENT) = $ACS_NONTRANSPARENT Then $ret &= "$ACS_NONTRANSPARENT"
		Case "button"
			If BitAND($var, $BS_LEFT) = $BS_LEFT Then $ret &= "$BS_LEFT+"
			If BitAND($var, $BS_RIGHT) = $BS_RIGHT Then $ret &= "$BS_RIGHT+"
			If BitAND($var, $BS_TOP) = $BS_TOP Then $ret &= "$BS_TOP+"
			If BitAND($var, $BS_BOTTOM) = $BS_BOTTOM Then $ret &= "$BS_BOTTOM+"
			If BitAND($var, $BS_CENTER) = $BS_CENTER Then $ret &= "$BS_CENTER+"
			If BitAND($var, $BS_DEFPUSHBUTTON) = $BS_DEFPUSHBUTTON Then $ret &= "$BS_DEFPUSHBUTTON+"
			If BitAND($var, $BS_MULTILINE) = $BS_MULTILINE Then $ret &= "$BS_MULTILINE+"
			If BitAND($var, $WS_BORDER) = $WS_BORDER Then $ret &= "$WS_BORDER+"
			If BitAND($var, $BS_VCENTER) = $BS_VCENTER Then $ret &= "$BS_VCENTER+"
			If BitAND($var, $BS_ICON) = $BS_ICON Then $ret &= "$BS_ICON+"
			If BitAND($var, $BS_BITMAP) = $BS_BITMAP Then $ret &= "$BS_BITMAP+"
			If BitAND($var, $BS_FLAT) = $BS_FLAT Then $ret &= "$BS_FLAT+"
			If BitAND($var, $BS_NOTIFY) = $BS_NOTIFY Then $ret &= "$BS_NOTIFY+"
			If BitAND($var, $BS_PUSHBOX) = $BS_PUSHBOX Then $ret &= "$BS_PUSHBOX+"
			If BitAND($var, $BS_PUSHLIKE) = $BS_PUSHLIKE Then $ret &= "$BS_PUSHLIKE+"
			
;~ 			If BitAnd($var,$WS_GROUP) = $WS_GROUP Then $ret &= "$WS_GROUP+"
;~ 			If BitAnd($var,$WS_TABSTOP) = $WS_TABSTOP Then $ret &= "$WS_TABSTOP+"
;~ 			If BitAnd($var,$WS_HSCROLL) = $WS_HSCROLL Then $ret &= "$WS_HSCROLL+"
;~ 			If BitAnd($var,$WS_VSCROLL) = $WS_VSCROLL Then $ret &= "$WS_VSCROLL+"
;~ 			If BitAnd($var,$WS_VISIBLE) = $WS_VISIBLE Then $ret &= "$WS_VISIBLE+"
;~ 			If BitAnd($var,$WS_CHILD) = $WS_CHILD Then $ret &= "$WS_CHILD+"
;~ 			If BitAnd($var,$WS_CLIPSIBLINGS) = $WS_CLIPSIBLINGS Then $ret &= "$WS_CLIPSIBLINGS+"
		Case "checkbox"
			$ret = _KodaGetCtrlStyle($var, "button"); bentuzt die selben Styles wie Button
			If BitAND($var, $BS_CHECKBOX) = $BS_CHECKBOX Then $ret &= "$BS_CHECKBOX+"
			If BitAND($var, $BS_AUTOCHECKBOX) = $BS_AUTOCHECKBOX Then $ret &= "$BS_AUTOCHECKBOX+"
			If BitAND($var, $BS_3STATE) = $BS_3STATE Then $ret &= "$BS_3STATE+"
			If BitAND($var, $BS_AUTO3STATE) = $BS_AUTO3STATE Then $ret &= "$BS_AUTO3STATE+"
			If BitAND($var, $BS_RIGHTBUTTON) = $BS_RIGHTBUTTON Then $ret &= "$BS_RIGHTBUTTON+"
			If BitAND($var, $BS_AUTORADIOBUTTON) = $BS_AUTORADIOBUTTON Then $ret &= "$BS_AUTORADIOBUTTON+"
		Case "combo"
			If BitAND($var, $CBS_AUTOHSCROLL) = $CBS_AUTOHSCROLL Then $ret &= "$CBS_AUTOHSCROLL+"
			If BitAND($var, $CBS_DISABLENOSCROLL) = $CBS_DISABLENOSCROLL Then $ret &= "$CBS_DISABLENOSCROLL+"
			If BitAND($var, $CBS_DROPDOWN) = $CBS_DROPDOWN Then $ret &= "$CBS_DROPDOWN+"
			If BitAND($var, $CBS_DROPDOWNLIST) = $CBS_DROPDOWNLIST Then $ret &= "$CBS_DROPDOWNLIST+"
			If BitAND($var, $CBS_HASSTRINGS) = $CBS_HASSTRINGS Then $ret &= "$CBS_HASSTRINGS+"
			If BitAND($var, $CBS_LOWERCASE) = $CBS_LOWERCASE Then $ret &= "$CBS_LOWERCASE+"
			If BitAND($var, $CBS_NOINTEGRALHEIGHT) = $CBS_NOINTEGRALHEIGHT Then $ret &= "$CBS_NOINTEGRALHEIGHT+"
			If BitAND($var, $CBS_OEMCONVERT) = $CBS_OEMCONVERT Then $ret &= "$CBS_OEMCONVERT+"
			If BitAND($var, $CBS_OWNERDRAWFIXED) = $CBS_OWNERDRAWFIXED Then $ret &= "$CBS_OWNERDRAWFIXED+"
			If BitAND($var, $CBS_OWNERDRAWVARIABLE) = $CBS_OWNERDRAWVARIABLE Then $ret &= "$CBS_OWNERDRAWVARIABLE+"
			If BitAND($var, $CBS_SIMPLE) = $CBS_SIMPLE Then $ret &= "$CBS_SIMPLE+"
			If BitAND($var, $CBS_SORT) = $CBS_SORT Then $ret &= "$CBS_SORT+"
			If BitAND($var, $CBS_UPPERCASE) = $CBS_UPPERCASE Then $ret &= "$CBS_UPPERCASE+"
		Case "date"
			If BitAND($var, $DTS_SHORTDATEFORMAT) = $DTS_SHORTDATEFORMAT Then $ret &= "$DTS_SHORTDATEFORMAT+"
			If BitAND($var, $DTS_UPDOWN) = $DTS_UPDOWN Then $ret &= "$DTS_UPDOWN+"
			If BitAND($var, $DTS_SHOWNONE) = $DTS_SHOWNONE Then $ret &= "$DTS_SHOWNONE+"
			If BitAND($var, $DTS_LONGDATEFORMAT) = $DTS_LONGDATEFORMAT Then $ret &= "$DTS_LONGDATEFORMAT+"
			If BitAND($var, $DTS_TIMEFORMAT) = $DTS_TIMEFORMAT Then $ret &= "$DTS_TIMEFORMAT+"
			If BitAND($var, $DTS_RIGHTALIGN) = $DTS_RIGHTALIGN Then $ret &= "$DTS_RIGHTALIGN+"
			If BitAND($var, $DTS_SHORTDATECENTURYFORMAT) = $DTS_SHORTDATECENTURYFORMAT Then $ret &= "$DTS_SHORTDATECENTURYFORMAT+"
			If BitAND($var, $DTS_APPCANPARSE) = $DTS_APPCANPARSE Then $ret &= "$DTS_APPCANPARSE+"
			
		Case Else
;~ 			If BitAnd($var,$) = $ Then $ret &= "$"
	EndSwitch

	; Button
;~ 	If BitAND($var,$) = $test Then $ret &= ""
	$ret = StringTrimRight($ret, 1); Remove trailing +
	Return $ret
EndFunc   ;==>_KodaGetCtrlStyle

Func _KodaGetGuiStyle($var)
	Local $ret = ""
	If BitAND($var, $WS_TILED) = $WS_TILED Then $ret &= "$WS_TILED+"
	If BitAND($var, $WS_OVERLAPPED) = $WS_OVERLAPPED Then $ret &= "$WS_OVERLAPPED+"
	If BitAND($var, $WS_MAXIMIZEBOX) = $WS_MAXIMIZEBOX Then $ret &= "$WS_MAXIMIZEBOX+"
	If BitAND($var, $WS_MINIMIZEBOX) = $WS_MINIMIZEBOX Then $ret &= "$WS_MINIMIZEBOX+"
	If BitAND($var, $WS_TABSTOP) = $WS_TABSTOP Then $ret &= "$WS_TABSTOP+"
	If BitAND($var, $WS_GROUP) = $WS_GROUP Then $ret &= "$WS_GROUP+"
	If BitAND($var, $WS_SIZEBOX) = $WS_SIZEBOX Then $ret &= "$WS_SIZEBOX+"
	If BitAND($var, $WS_THICKFRAME) = $WS_THICKFRAME Then $ret &= "$WS_THICKFRAME+"
	If BitAND($var, $WS_SYSMENU) = $WS_SYSMENU Then $ret &= "$WS_SYSMENU+"
	If BitAND($var, $WS_HSCROLL) = $WS_HSCROLL Then $ret &= "$WS_HSCROLL+"
	If BitAND($var, $WS_VSCROLL) = $WS_VSCROLL Then $ret &= "$WS_VSCROLL+"
	If BitAND($var, $WS_DLGFRAME) = $WS_DLGFRAME Then $ret &= "$WS_DLGFRAME+"
	If BitAND($var, $WS_BORDER) = $WS_BORDER Then $ret &= "$WS_BORDER+"
	If BitAND($var, $WS_CAPTION) = $WS_CAPTION Then $ret &= "$WS_CAPTION+"
	If BitAND($var, $WS_OVERLAPPEDWINDOW) = $WS_OVERLAPPEDWINDOW Then $ret &= "$WS_OVERLAPPEDWINDOW+"
	If BitAND($var, $WS_TILEDWINDOW) = $WS_TILEDWINDOW Then $ret &= "$WS_TILEDWINDOW+"
	If BitAND($var, $WS_MAXIMIZE) = $WS_MAXIMIZE Then $ret &= "$WS_MAXIMIZE+"
	If BitAND($var, $WS_CLIPCHILDREN) = $WS_CLIPCHILDREN Then $ret &= "$WS_CLIPCHILDREN+"
	If BitAND($var, $WS_CLIPSIBLINGS) = $WS_CLIPSIBLINGS Then $ret &= "$WS_CLIPSIBLINGS+"
	If BitAND($var, $WS_DISABLED) = $WS_DISABLED Then $ret &= "$WS_DISABLED+"
	If BitAND($var, $WS_VISIBLE) = $WS_VISIBLE Then $ret &= "$WS_VISIBLE+"
	If BitAND($var, $WS_MINIMIZE) = $WS_MINIMIZE Then $ret &= "$WS_MINIMIZE+"
	If BitAND($var, $WS_CHILD) = $WS_CHILD Then $ret &= "$WS_CHILD+"
	If BitAND($var, $WS_POPUP) = $WS_POPUP Then $ret &= "$WS_POPUP+"
	If BitAND($var, $WS_POPUPWINDOW) = $WS_POPUPWINDOW Then $ret &= "$WS_POPUPWINDOW+"
	
	If BitAND($var, $DS_MODALFRAME) = $DS_MODALFRAME Then $ret &= "$DS_MODALFRAME+"
	If BitAND($var, $DS_SETFOREGROUND) = $DS_SETFOREGROUND Then $ret &= "$DS_SETFOREGROUND+"
	If BitAND($var, $DS_CONTEXTHELP) = $DS_CONTEXTHELP Then $ret &= "$DS_CONTEXTHELP+"
	
	Return $ret
EndFunc   ;==>_KodaGetGuiStyle

Func _KodaGetExStyle($var)
	Local $ret = ""
	
	If BitAND($var, $WS_EX_ACCEPTFILES) = $WS_EX_ACCEPTFILES Then $ret &= "$WS_EX_ACCEPTFILES+"
	If BitAND($var, $WS_EX_MDICHILD) = $WS_EX_MDICHILD Then $ret &= "$WS_EX_MDICHILD+"
	If BitAND($var, $WS_EX_APPWINDOW) = $WS_EX_APPWINDOW Then $ret &= "$WS_EX_APPWINDOW+"
	If BitAND($var, $WS_EX_COMPOSITED) = $WS_EX_COMPOSITED Then $ret &= "$WS_EX_COMPOSITED+"
	If BitAND($var, $WS_EX_CLIENTEDGE) = $WS_EX_CLIENTEDGE Then $ret &= "$WS_EX_CLIENTEDGE+"
	If BitAND($var, $WS_EX_CONTEXTHELP) = $WS_EX_CONTEXTHELP Then $ret &= "$WS_EX_CONTEXTHELP+"
	If BitAND($var, $WS_EX_DLGMODALFRAME) = $WS_EX_DLGMODALFRAME Then $ret &= "$WS_EX_DLGMODALFRAME+"
	If BitAND($var, $WS_EX_LEFTSCROLLBAR) = $WS_EX_LEFTSCROLLBAR Then $ret &= "$WS_EX_LEFTSCROLLBAR+"
	If BitAND($var, $WS_EX_OVERLAPPEDWINDOW) = $WS_EX_OVERLAPPEDWINDOW Then $ret &= "$WS_EX_OVERLAPPEDWINDOW+"
	If BitAND($var, $WS_EX_RIGHT) = $WS_EX_RIGHT Then $ret &= "$WS_EX_RIGHT+"
	If BitAND($var, $WS_EX_STATICEDGE) = $WS_EX_STATICEDGE Then $ret &= "$WS_EX_STATICEDGE+"
	If BitAND($var, $WS_EX_TOOLWINDOW) = $WS_EX_TOOLWINDOW Then $ret &= "$WS_EX_TOOLWINDOW+"
	If BitAND($var, $WS_EX_TOPMOST) = $WS_EX_TOPMOST Then $ret &= "$WS_EX_TOPMOST+"
	If BitAND($var, $WS_EX_TRANSPARENT) = $WS_EX_TRANSPARENT Then $ret &= "$WS_EX_TRANSPARENT+"
	If BitAND($var, $WS_EX_WINDOWEDGE) = $WS_EX_WINDOWEDGE Then $ret &= "$WS_EX_WINDOWEDGE+"
	If BitAND($var, $WS_EX_LAYERED) = $WS_EX_LAYERED Then $ret &= "$WS_EX_LAYERED+"
	If BitAND($var, $WS_EX_CONTROLPARENT) = $WS_EX_CONTROLPARENT Then $ret &= "$WS_EX_CONTROLPARENT+"
	If BitAND($var, $WS_EX_LAYOUTRTL) = $WS_EX_LAYOUTRTL Then $ret &= "$WS_EX_LAYOUTRTL+"
	If BitAND($var, $WS_EX_RTLREADING) = $WS_EX_RTLREADING Then $ret &= "$WS_EX_RTLREADING+"
	
	$ret = StringTrimRight($ret, 1); Remove trailing +
	Return $ret
EndFunc   ;==>_KodaGetExStyle

Func _KodaGetOptVarScope($var)
	Local $ret = 0
	Switch $var
		Case 0
			$ret = 0
		Case 1
			$ret = "global"
		Case 2
			$ret = "local"
		Case Else
			$ret = 0
	EndSwitch
	Return $ret
EndFunc   ;==>_KodaGetOptVarScope


Func _KodaGetHexColor($var, ByRef $ext)
	Local $ret = "0x"
	Switch $var
		Case "clBlack"
			$ret = "0x000000"
		Case "clMaroon"
			$ret = "0x800000"
		Case "clGreen"
			$ret = "0x008000"
		Case "clOlive"
			$ret = "0x808000"
		Case "clNavy"
			$ret = "0x000080"
		Case "clPurple"
			$ret = "0x800080"
		Case "clTeal"
			$ret = "0x008080"
		Case "clGray"
			$ret = "0x808080"
		Case "clSilver"
			$ret = "0xC0C0C0"
		Case "clRed"
			$ret = "0xFF0000"
		Case "clLime"
			$ret = "0x00FF00"
		Case "clYellow"
			$ret = "0xFFFF00"
		Case "clBlue"
			$ret = "0x0000FF"
		Case "clFuchsia"
			$ret = "0xFF00FF"
		Case "clAqua"
			$ret = "0x00FFFF"
		Case "clWhite"
			$ret = "0xFFFFFF"
		Case "clMoneyGreen"
			$ret = "0xC0DCC0"
		Case "clSkyBlue"
			$ret = "0xA6CAF0"
		Case "clCream"
			$ret = "0xFFFBF0"
		Case "clMedGray"
			$ret = "0xA0A0A4"
		Case "clnone"
			$ret = "0xFFFFFF"
		Case "clActiveBorder"
			;_WinAPI_GetSysColor($COLOR_ACTIVEBORDER)
			$ret = _WinAPI_GetSysColor($COLOR_ACTIVEBORDER)
			$ext = "$COLOR_ACTIVEBORDER"
		Case "clActiveCaption"
			;_WinAPI_GetSysColor($COLOR_ACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_ACTIVECAPTION)
			$ext = "$COLOR_ACTIVECAPTION"
		Case "clAppWorkSpace"
			;_WinAPI_GetSysColor($COLOR_APPWORKSPACE)
			$ret = _WinAPI_GetSysColor($COLOR_APPWORKSPACE)
			$ext = "$COLOR_APPWORKSPACE"
		Case "clBackground"
			;_WinAPI_GetSysColor($COLOR_BACKGROUND)
			$ret = _WinAPI_GetSysColor($COLOR_BACKGROUND)
			$ext = "$COLOR_BACKGROUND"
		Case "clBtnFace"
			;_WinAPI_GetSysColor($COLOR_BTNFACE)
			$ret = _WinAPI_GetSysColor($COLOR_BTNFACE)
			$ext = "$COLOR_BTNFACE"
		Case "clBtnHighlight"
			;_WinAPI_GetSysColor($COLOR_BTNHIGHLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_BTNHIGHLIGHT)
			$ext = "$COLOR_BTNHIGHLIGHT"
		Case "clBtnShadow"
			;_WinAPI_GetSysColor($COLOR_BTNSHADOW)
			$ret = _WinAPI_GetSysColor($COLOR_BTNSHADOW)
			$ext = "$COLOR_BTNSHADOW"
		Case "clBtnText"
			;_WinAPI_GetSysColor($COLOR_BTNTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_BTNTEXT)
			$ext = "$COLOR_BTNTEXT"
		Case "clCaptionText"
			;_WinAPI_GetSysColor($COLOR_CAPTIONTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_CAPTIONTEXT)
			$ext = "$COLOR_CAPTIONTEXT"
		Case "clGradientActiveCaption"
			;_WinAPI_GetSysColor($COLOR_GRADIENTACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_GRADIENTACTIVECAPTION)
			$ext = "$COLOR_GRADIENTACTIVECAPTION"
		Case "clGradientInactiveCaption"
			;_WinAPI_GetSysColor($COLOR_GRADIENTINACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_GRADIENTINACTIVECAPTION)
			$ext = "$COLOR_GRADIENTACTIVECAPTION"
		Case "clGrayText"
			;_WinAPI_GetSysColor($COLOR_GRAYTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_GRAYTEXT)
			$ext = "$COLOR_GRAYTEXT"
		Case "clHighlight"
			;_WinAPI_GetSysColor($COLOR_HIGHLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_HIGHLIGHT)
			$ext = "$COLOR_HIGHLIGHT"
		Case "clHighlightText"
			;_WinAPI_GetSysColor($COLOR_HIGHLIGHTTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_HIGHLIGHTTEXT)
			$ext = "$COLOR_HIGHLIGHTTEXT"
		Case "clHotlight"
			;_WinAPI_GetSysColor($COLOR_HOTLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_HOTLIGHT)
			$ext = "$COLOR_HOTLIGHT"
		Case "clInactiveBorder"
			;_WinAPI_GetSysColor($COLOR_INACTIVEBORDER)
			$ret = _WinAPI_GetSysColor($COLOR_INACTIVEBORDER)
			$ext = "$COLOR_INACTIVEBORDER"
		Case "clInactiveCaption"
			;_WinAPI_GetSysColor($COLOR_INACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_INACTIVECAPTION)
			$ext = "$COLOR_INACTIVECAPTION"
		Case "clInactiveCaptionText"
			;_WinAPI_GetSysColor($COLOR_INACTIVECAPTIONTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_INACTIVECAPTIONTEXT)
			$ext = "$COLOR_INACTIVECAPTIONTEXT"
		Case "clInfoBK"
			;_WinAPI_GetSysColor($COLOR_INFOBK)
			$ret = _WinAPI_GetSysColor($COLOR_INFOBK)
			$ext = "$COLOR_INFOBK"
		Case "clInfoText"
			;_WinAPI_GetSysColor($COLOR_INFOTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_INFOTEXT)
			$ext = "$COLOR_INFOTEXT"
		Case "clMenu"
			;_WinAPI_GetSysColor($COLOR_MENU)
			$ret = _WinAPI_GetSysColor($COLOR_MENU)
			$ext = "$COLOR_MENU"
		Case "clMenuBar"
			;_WinAPI_GetSysColor($COLOR_MENUBAR)
			$ret = _WinAPI_GetSysColor($COLOR_MENUBAR)
			$ext = "$COLOR_MENUBAR"
		Case "clMenuHighlight"
			;_WinAPI_GetSysColor($COLOR_MENUHIGHLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_MENUHIGHLIGHT)
			$ext = "$COLOR_MENUHIGHLIGHT"
		Case "clMenuText"
			;_WinAPI_GetSysColor($COLOR_MENUTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_MENUTEXT)
			$ext = "$COLOR_MENUTEXT"
		Case "clScrollbar"
			;_WinAPI_GetSysColor($COLOR_SCROLLBAR)
			$ret = _WinAPI_GetSysColor($COLOR_SCROLLBAR)
			$ext = "$COLOR_SCROLLBAR"
		Case "cl3DDkShadow"
			;_WinAPI_GetSysColor($COLOR_3DDKSGADOW)
			$ret = _WinAPI_GetSysColor($COLOR_3DDKSGADOW)
			$ext = "$COLOR_3DDKSGADOW"
		Case "cl3DLight"
			;_WinAPI_GetSysColor($COLOR_3DLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_3DLIGHT)
			$ext = "$COLOR_3DLIGHT"
		Case "clWindow"
			;_WinAPI_GetSysColor($COLOR_WINDOW)
			$ret = _WinAPI_GetSysColor($COLOR_WINDOW)
			$ext = "$COLOR_WINDOW"
		Case "clWindowFrame"
			;_WinAPI_GetSysColor($COLOR_WINDOWFRAME)
			$ret = _WinAPI_GetSysColor($COLOR_WINDOWFRAME)
			$ext = "$COLOR_WINDOWFRAME"
		Case "clWindowText"
			;_WinAPI_GetSysColor($COLOR_WINDOWTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_WINDOWTEXT)
			$ext = "$COLOR_WINDOWTEXT"
		Case Else
			ConsoleWrite("Not supported Format: " & $var & @LF)
			
			; andere Formate knnen mit _WinAPI_GetSysColor(IDENT) ausgelesen werden. Problem: ist iin KODA nur mit der lokalen Einstellung abzuspeichern, wenn ein Code generiert wird.
	EndSwitch
	$ret = "0x" & Hex($ret, 6)
	Return $ret
EndFunc   ;==>_KodaGetHexColor

Func _KodaGetBool($s)
	If $s = "True" Then Return 1
	Return 0
EndFunc

